# frozen_string_literal: true

# Copyright (C) 2024 Manuel Bustillo

module Tables
  class Swap
    private attr_reader :initial_solution
    def initialize(initial_solution)
      @initial_solution = initial_solution
    end

    def each
      @initial_solution.tables.combination(2) do |table_a, table_b|
        table_a.to_a.product(table_b.to_a).each do |(person_a, person_b)|
          original_discomfort_a = table_a.reset
          original_discomfort_b = table_b.reset

          table_a.delete(person_a)
          table_b.delete(person_b)

          table_a << person_b
          table_b << person_a

          yield(@initial_solution)
        ensure
          table_a.delete(person_b)
          table_b.delete(person_a)

          table_a << person_a
          table_b << person_b

          table_a.discomfort = original_discomfort_a
          table_b.discomfort = original_discomfort_b
        end
      end
    end
  end
end
